#include <ntddk.H>

#ifndef _FILTER_
#define _FILTER_

typedef struct _DEVICE_EXTENSION 
{
	PDEVICE_OBJECT NextLowerDriver; /* Next Layer device object */
	PDEVICE_OBJECT Self; /* Self device object */
}DEVICE_EXTENSION, *PDEVICE_EXTENSION;

NTSTATUS
FilterAddDevice(
    IN PDRIVER_OBJECT DriverObject,
    IN PDEVICE_OBJECT PhysicalDeviceObject
    );

VOID                                                                
FilterUnload                                                       
	(                                                               
	IN PDRIVER_OBJECT DriverObject  /* pointer to device object */
	);

NTSTATUS
FilterDispatchPnp
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to device object */
	IN PIRP Irp                         /* pointer to an I/O request packet */
	);

NTSTATUS                                                            
FilterDispatchPower
	(                                                               
		IN PDEVICE_OBJECT DeviceObject,                             
		IN PIRP Irp                                                 
	);

NTSTATUS
FilterPass (
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    );

#endif //_FILTER_
