#ifndef _POWER_H_
#define _POWER_H_

typedef struct _POWER_COMPLETION_CONTEXT {

    PDEVICE_OBJECT  DeviceObject;
    PIRP            Irp;

    BOOLEAN bDevicePowerStrategyUp2Low;
    DEVICE_POWER_STATE OldState;

} POWER_COMPLETION_CONTEXT, *PPOWER_COMPLETION_CONTEXT;

#define SET_MYDEVICE_POWER_STATE(PowerLevel) \
{ \
	deviceExtension->DevicePowerState = PowerLevel; \
	{ \
		POWER_STATE NewState; \
		NewState.DeviceState = PowerLevel; \
		PoSetPowerState( DeviceObject, DevicePowerState, NewState ); \
	} \
}\


NTSTATUS SAMPLE_PowerDispatch( PDEVICE_OBJECT DeviceObject, PIRP Irp );

#endif

