#include <ntddk.H>

#ifndef _SAMPLE_
#define _SAMPLE_

typedef struct _DEVICE_EXTENSION 
{
	PDEVICE_OBJECT PhysicalDeviceObject; /* physical device object */
	PDEVICE_OBJECT NextLayerDeviceObject; /* Next Layer device object */
	PDEVICE_OBJECT DeviceObject; /* Self device object */
	UNICODE_STRING UnicodeString; 
	// ڿ  DeviceStack  ̸ ϴ°
}DEVICE_EXTENSION, *PDEVICE_EXTENSION;

NTSTATUS
SAMPLE2_AddDevice
	(
	IN PDRIVER_OBJECT DriverObject,         
	IN PDEVICE_OBJECT PhysicalDeviceObject  
	);

VOID                                                                
SAMPLE2_Unload                                                       
	(                                                               
	IN PDRIVER_OBJECT DriverObject  /* pointer to device object */
	);

NTSTATUS
SAMPLE2_DeferIrpCompletion
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to a device object */
	IN PIRP Irp,                        /* pointer to a I/O request packet */
	IN PVOID Context                    /* driver defined context */
	);

NTSTATUS
SAMPLE2_Create
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to device object */
	IN PIRP Irp                         /* pointer to an I/O request packet */
	);

NTSTATUS
SAMPLE2_Read
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to device object */
	IN PIRP Irp                         /* pointer to an I/O request packet */
	);

NTSTATUS
SAMPLE2_Write
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to device object */
	IN PIRP Irp                         /* pointer to an I/O request packet */
	);

NTSTATUS
SAMPLE2_Close
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to device object */
	IN PIRP Irp                         /* pointer to an I/O request packet */
	);

NTSTATUS
SAMPLE2_PnpDispatch
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to device object */
	IN PIRP Irp                         /* pointer to an I/O request packet */
	);

NTSTATUS
SAMPLE2_PowerDispatch
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to device object */
	IN PIRP Irp                         /* pointer to an I/O request packet */
	);

#endif //_SAMPLE_
