#ifndef _F_IFACE_H_
#define _F_IFACE_H_

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Application Interface

// ϼ ؼ ߰
#define HIDDEN_CMD    0x900

#define IOCTL_HIDDEN_FILES CTL_CODE(FILE_DEVICE_UNKNOWN, HIDDEN_CMD + 0x0001, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_SHOW_FILES CTL_CODE(FILE_DEVICE_UNKNOWN, HIDDEN_CMD + 0x0002, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_ADD_HIDDEN_FILE CTL_CODE(FILE_DEVICE_UNKNOWN, HIDDEN_CMD + 0x0003, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_DEL_HIDDEN_FILE CTL_CODE(FILE_DEVICE_UNKNOWN, HIDDEN_CMD + 0x0004, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_ALL_RESET_HIDDEN_FILES CTL_CODE(FILE_DEVICE_UNKNOWN, HIDDEN_CMD + 0x0005, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_SET_DRIVE CTL_CODE(FILE_DEVICE_UNKNOWN, HIDDEN_CMD + 0x0006, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_SET_EVENT CTL_CODE(FILE_DEVICE_UNKNOWN, HIDDEN_CMD + 0x0007, METHOD_BUFFERED, FILE_ANY_ACCESS)

//  ɿ Ǵ ü
#define MAXHIDDENFILEENTRIES 100
#define MAXHIDDENFILENAMESIZE 1024

typedef struct
{
	WCHAR Filename[MAXHIDDENFILENAMESIZE];
} ADD_HIDDEN_FILE, *PADD_HIDDEN_FILE;

typedef struct
{
	ULONG Handle;
} HIDDEN_FILE_HANDLE, *PHIDDEN_FILE_HANDLE;

typedef struct
{
	HIDDEN_FILE_HANDLE Handle;
} DEL_HIDDEN_FILE, *PDEL_HIDDEN_FILE;

typedef struct
{
	HANDLE hEvent;
} SEND_EVENT, *PSEND_EVENT;

typedef struct
{
	char Drive; // ASCII, ex) 'C', 'D'
} SEND_DRIVE, *PSEND_DRIVE;

#endif // _F_IFACE_H_
